<template>
  <div class="container">
    <div class="product-header">
      <div class="row">
        <h2>Produk</h2>
        <select
          name="sortBy"
          id="sortBy"
          @change="handleSort(sortType)"
          v-model="sortType"
        >
          <option
            v-for="item in sortOptions"
            :value="item.value"
            :key="item.value"
            >{{ item.text }}</option
          >
        </select>
      </div>
    </div>
    <div class="product-list">
      <product-card
        v-for="product in products"
        :key="product.id"
        :product="product"
      ></product-card>
    </div>
    <div v-if="isLoading">
      <p style="padding-top: 30px"><strong>Mohon Tunggu . . . . .</strong></p>
      <p>
        Mungkin butuh beberapa saat untuk mengaktifkan kembali server data kami
        di heroku ...
      </p>
    </div>
  </div>
</template>

<script>
import { mapState } from "vuex";
export default {
  data() {
    return {
      filter: {
        search: "",
        sort: "name,asc"
      },
      sortType: "",
      sortOptions: [
        { text: "Urut Berdasarkan", value: "" },
        { text: "Harga Terendah", value: "price,asc" },
        { text: "Terpopuler", value: "favorite,desc" },
        { text: "Rating", value: "rating,desc" }
      ]
    };
  },
  created() {
    this.fetchRecords();
  },
  computed: {
    ...mapState({
      products: state => state.products.products,
      isLoading: state => state.loading
    })
  },
  methods: {
    fetchRecords() {
      this.$store.dispatch("products/fetch");
    },
    handleSort(sort) {
      if (sort !== "") {
        this.$store.commit("products/SET_SORTING_PRODUCT", sort);
        this.fetchRecords();
      }
    }
  },
  watch: {
    "$route.query": {
      handler(query) {
        this.$store.commit("products/SET_SEARCH_PRODUCT", query.search);
        this.fetchRecords();
      },
      immediate: true
    }
  }
};
</script>

<style lang="scss" scoped>
.product-header {
  justify-content: space-between;

  .row {
    justify-content: space-between;
  }
}
.product-list {
  display: flex;
  flex-wrap: wrap;
  margin: 0px -8px;
  justify-content: flex-start;
}

@media screen and (max-width: 600px) {
  .product-list {
    justify-content: center;
  }
}
</style>
